package es.prodevelop.gvsig.mini.utiles; 
/* This work is part of the 59Pixels Library
 *
 * 59Pixels J2ME Library by Alan Clelland - 59Pixels is licensed under a Creative Commons Attribution-Share Alike 3.0 Unported License.
 * Based on a work at www.59pixels.com. 
 *
 * You are free to edit, sell and redistribute this file as much as you want as long as you
 * keep this disclaimer in the file where ever you distribute the code.
 * 
 */

import java.util.Stack;

/**
 *
 * @author aclelland
 */
public class ExtString59 {
    
    private static Stack stringStack;
    private static StringBuffer buffer;
    
    public static String replace(String text,String replace,String insert)
    {
          buffer = new StringBuffer();
          byte found = 0;
          
          for(int i = 0;i<text.length();i++)
          {
              if(text.charAt(i) == replace.charAt(0))
              {
                  found= 1;
                  for(int j = 0;j<replace.length();j++)
                  {
                      if(text.charAt(i+j) != replace.charAt(j))
                      {
                          found=0;
                          break;
                      }
                  }
                  
                  if(found == 1)
                  {
                      buffer.append(insert);
                      i+= replace.length()-1;
                      continue;
                  }
              }
              else
              {
                  buffer.append((char)text.charAt(i));
              }   
          }
          
          return buffer.toString();
    }
    
    public static String[] split(String toSplit,char delim,boolean ignoreEmpty)
    {
        buffer = new StringBuffer();
        stringStack = new Stack();
        for(int i = 0;i<toSplit.length();i++)
        {
            if(toSplit.charAt(i) != delim)
            {
               
                buffer.append((char)toSplit.charAt(i));
            }
            else
            {
                if(buffer.toString().trim().length() == 0 && ignoreEmpty)
                {
                    
                }
                else
                {
                    stringStack.addElement(buffer.toString());
                }
                buffer = new StringBuffer();
            }
        }
        
        if(buffer.length() != 0)
            stringStack.addElement(buffer.toString());
        
        
        String [] split = new String[stringStack.size()];
        for(int i = 0;i<split.length;i++)
        {
            split[split.length-1-i] = (String)stringStack.pop();
        }
        
        stringStack = null;
        buffer = null;
        return split;
    }
    
    public static String reverse(String text)
    {
        buffer = new StringBuffer();
        for(int i = 0;i<text.length();i++)
        {
            buffer.append((char)text.charAt(text.length()-1-i));
        }
        
        return buffer.toString();
    }
    
    public static String removeExtraSpaces(String text,boolean removeLeadingAndTrailingSpaces)
    {
        buffer = new StringBuffer();
        if(removeLeadingAndTrailingSpaces)
            text = text.trim();
        
        byte wasASpace =0;
        
        for(int i =0;i<text.length();i++)
        {
            if(text.charAt(i) == ' ' && wasASpace == 1)
            {
                continue;
            }
            else if(text.charAt(i) == ' ')
            {
                wasASpace = 1;
            }
            else
                wasASpace = 0;
            
            buffer.append((char)text.charAt(i));
        }
        
        return buffer.toString();
    }
    
    public static boolean areEqualIgnoreCase(String text,String compair)
    {
        if(text.toLowerCase().equals(compair.toLowerCase()))
            return true;
        else
            return false;
    }
    
}